function [NewSig,E,D] = PCA(OldSig,varargin)

% PCA ---- Performing PCA algorithm to the input signals
% øʽ
%     [NewSig,E,D] = PCA(OldSig,'PCNum',4,'minIndex',1,'maxIndex',4,'report','on')
%     [NewSig,E,D] = PCA(OldSig,'PCNum',10,'report','off')
%
% ˵:
%      ||   ȡֵ   ||  ˵ 
%     'PCNum'              ҪûòminIndexmaxIndexЧ
%  'minIndex'              ѡСֵţEIGֵֽеţ
%  'maxIndex'              ѡֵţEIGֵֽеţ  
%    'report'      [ 'on' |       'on'ʾʾеϢ
%                    'off']       'off'ʾʾϢ
%     OldSig                       źžÿдһźţÿдźŵһι۲
%     NewSig                       ľPCAźž
%          E                       PCA
%          D                       PCAֵ
%
% ע⣺
%     ѡɶ롣ǰӦĲֵעֵַ
%
% ο
%     SELCOL  FFPICA
%
% ߣ֣Zhang Zhi-Lin
%       ִźŴʵ
% 汾1.1
% ڣ20031116



OldDim=size(OldSig,1);
%======================================================================
% Ĭֵ
PCNum=OldDim;
minIndex=1;
maxIndex=OldDim;
report='on';

enterPCNum=0;      % ־ûǷPCNumֵΪ1ʾûPCNumֵ
                   % ʱûminIndexmaxIndexЧû
                   % PCNumֵPCA

                   
%======================================================================
% ȡѡ
if(mod(length(varargin),2)==1)
    error('Optional parameters should always go by pairs.\n');
else
    for i=1:2:(length(varargin)-1)
        switch lower(varargin{i})
            case 'pcnum'
                PCNum=varargin{i+1};
                enterPCNum=1;  % ûPCNumֵʱûminIndexmaxIndexֵЧ
            case 'minindex'
                minIndex=varargin{i+1};
            case 'maxindex'
                maxIndex=varargin{i+1};
            case 'report'
                report=lower(varargin{i+1});
            otherwise
                error(['Unrecognized parameter: ''' varargin{i} '''']);
        end
    end
end


%====================================================================
% ȷ
if ~( strcmp(report,'on') | strcmp(report,'off') )
    error(sprintf('Illegal value [ %s ] for parameter: ''report''\n', report));
end

if ~isreal(OldSig)
    error('Input matrix has an imaginary part.\n');
end

if ~isnumeric(minIndex) 
    error(sprintf('Illegal value for parameter: ''minIndex'', it must be number\n', minIndex));
elseif minIndex > OldDim | minIndex < 1
    error(sprintf('Illegal value for parameter: ''minIndex'', input correct value\n', minIndex));
end

if ~isnumeric(maxIndex) 
    error(sprintf('Illegal value for parameter: ''maxIndex'', it must be number\n', maxIndex));
elseif maxIndex > OldDim | maxIndex < minIndex 
    error(sprintf('Illegal value for parameter: ''maxIndex'', input correct value\n', maxIndex));    
end

if ~isnumeric(PCNum) | PCNum > OldDim
    error(sprintf('Illegal value for parameter: ''PCNum'', it must be number or correct value\n', PCNum));
end


%-------------------------------------------------------------------------
% ûPCNumֵм
if enterPCNum ==1        
    maxIndex = OldDim;
    minIndex = OldDim-PCNum+1;
end


%=========================================================================
% PCA
if strcmp(report,'on') fprintf('Calculating PCA ...\n'); end

covarianceMatrix=cov(OldSig',1);          % Э
nonZeroEig=rank(covarianceMatrix,1e-9);   % ЭȣҲ
[E,D]=eig(covarianceMatrix);              % ֵ,עֵС
nonZeroIndex = OldDim - nonZeroEig + 1;   % Сֵ


%--------------------------------------------------------------------------
% Ƿά
if minIndex < nonZeroIndex
    minIndex = nonZeroIndex;        % ʹСֵ  Сķֵ
    if strcmp(report,'on') 
        fprintf('Dimension reduced from %d to %d because of the singularity of covaricance matrix\n', ... 
                 OldDim,maxIndex - minIndex +1); 
    end
else  
    if strcmp(report,'on') 
        if OldDim == (maxIndex - minIndex + 1)
            fprintf('Dimension has not reduced.\n');
        else
            fprintf('Dimension reduced from %d to %d\n',OldDim,maxIndex - minIndex +1);
        end
    end
end
 

%--------------------------------------------------------------------------
% ѡȡֵ
selectedColumns = zeros(OldDim,1);

for i=1:OldDim    % selectedColumnsеԪ1ʾѡȡӦŵֵ
    if (minIndex <= i) & (i <= maxIndex)
        selectedColumns(i)=1;
    end
end

sumTotal = sum(diag(D));                            % ԭźŵֵܺ
sumRemove = sum( diag(D).*(~selectedColumns) );     % ȥֵ֮

if strcmp(report,'on')
    fprintf('Smallest remaining(non-zero) eigenvalue: %d\n',D(minIndex,minIndex));
    fprintf('Largest remaining(non-zero) eigenvalue: %d\n',D(maxIndex,maxIndex));
    fprintf('Sum of removed eigenvalue: %d\n',sumRemove );
end

% ѡȡֵ
E=selcol( E, selectedColumns );
D=selcol( selcol(D,selectedColumns)', selectedColumns);

sumUsed = sum(diag(D));

if strcmp(report,'on')
    fprintf('%g%% of (non-zero)eigenvalues retained.\n',sumUsed/sumTotal*100);
end

NewSig = E'*OldSig;      % άȡõµźž

    

    
        
    
    





