function halfy = computPeriod(XX, lag, threshold)
% computPeriod -- ʾXX,ʾķΧǴӳ0ʱlag-1
% 
% Format:    halfy = computPeriod(XX, lag, threshold)
%
% Parameters:
%      halfy       -- ķֵʾڻԵʱṹ
%      XX          -- 
%      lag         -- ʱصݶӦʱ0ʱ(lag-1)
%      threshold   -- ֵĳ̶ȣͨ1-2֮䡣ֵԽʾķֵԽ
%
% See also
%      computPeriodDemo
%
% Reference:
%  [1]Zhi-Lin Zhang, Liqing Zhang, Extraction of Temporally Correlated Signals Using
%     a Two-Stage Method with Applications in Biomedical Engineering, submitted, 2006
%
% Author :  Zhi-Lin Zhang (zlzhang@uestc.edu.cn)
% Date   :  May 20, 2006
% Version:  1.0



LX = length(XX);  

% ȥֵȥ
XX=(XX-mean(XX))/cov(XX); 

% Ԥ
a = lpc(XX,10);

% ź
est_XX = filter([0 -a(2:end)],1,XX);    

% Ԥź
ee = XX - est_XX;                     

% Ԥźŵغ
y=xcorr(ee,lag-1);

% ׼
y=standarize(y); 

% ȥغеõ
y=sign(y).* max( abs(y)-threshold,   0 );

% % ͼʾ
halfy=y;  halfy(1:lag-1)=[];
% figure;  plot(halfy);  axis tight;
